stages:
  - build_docker_image
  - compile

#tag registry to force the use of gsanahuj's runner, instead of utc
#utc's runner need to implement this solution:
#https://techoverflow.net/2021/01/12/how-to-fix-gitlab-ci-error-during-connect-post-http-docker2375-v1-40-auth-dial-tcp-lookup-docker-on-no-such-host/
build_docker_image:
  image: "docker:latest"
  services:
    - name: docker:dind
  stage: build_docker_image
  tags:
    - linux
    - docker
    - registry
  variables:
   IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build --pull -t $IMAGE_TAG .
    - docker push $IMAGE_TAG
  when: manual

compile:
  image: "ubuntu:18.04"
  stage: compile
  tags:
    - docker
    - linux
  script:
    - export TZ=Europe/Paris
    - ln -snf /usr/share/zoneinfo/$TZ /etc/localtime && echo $TZ > /etc/timezone
    - apt-get update && apt-get install --no-install-recommends -y git libopencv-dev cmake ca-certificates gcc g++
    - git submodule update --init --recursive
    - mkdir build
    - cd build
    - cmake ..
    - make
